#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jun 24 15:06:04 2019

@author: lessig
"""

import numpy as np
import matplotlib.pyplot as plt

alpha = 1.;
siglen = 128;

###############################################################################
# projection of initial condition


###############################################################################
# analytic time integration


###############################################################################
# numerical time integration using Euler step


###############################################################################
# visualization

xx = np.linspace( 0.0, 2*np.pi, sig_ts[0].size)   
   
# plot analytic solution at different times 
fig, ax = plt.subplots( nrows=1, ncols=1 ) 
plt.plot( xx, sig_ts[0]) 
plt.plot( xx, sig_ts[25])    
plt.plot( xx, sig_ts[50])
plt.plot( xx, sig_ts[75])
plt.plot( xx, sig_ts[99])
ax.legend( ['t=0', 't=1.25', 't=2.5', 't=3.75', 't=5.'])
fig.savefig( '../images/heatflow_overview.pdf')
plt.show()
plt.close(fig)
   
# plot comparison to Euler and analytic solution
fig, ax = plt.subplots( nrows=1, ncols=1 ) 
plt.plot( xx, sig_ts[50]) 
plt.plot( xx, sig_euler_ts[0,50]) 
plt.plot( xx, sig_euler_ts[1,50]) 
plt.plot( xx, sig_euler_ts[2,50])    
ax.legend( ['analytic', 'Euler dt=0.001', 'Euler dt=0.0005',  'Euler dt=0.0001'])
fig.savefig( '../images/heatflow_comp_analytic_euler.pdf')
plt.show()
plt.close(fig)

# write out image files (for video generation)
# video can be generated on the command line with
# ffmpeg -r 15 -f image2 -i heatflow_0%*.png -vcodec libx264 -pix_fmt yuv420p heat_flow.mp4
#for i in range(ts.size) : 
#    fig, ax = plt.subplots( nrows=1, ncols=1 ) 
#    fig.set_size_inches( 10., 10.)
#    ax.plot( xx, sig_ts[i])
#    ax.set_ylim([0.0, 1.05])
#    ax.set_xticks( np.array([np.pi/2., np.pi, 3*np.pi/2., 2.*np.pi]) )
#    fig.savefig( '../images/heatflow_' + "{:04}".format(i))
#    plt.close(fig)    

    
    